datablock ParticleData(mixashootTetrakaikimboFlashParticle)
{
	dragCoefficient		= 3;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 1.0;
	constantAcceleration = 0.0;
	lifetimeMS			  = 25;
	lifetimeVarianceMS	= 15;
	textureName			 = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	  = 255/255 SPC 155/255 SPC 25/255 SPC "1.000";
	colors[1]	  = 242/255 SPC 141/255 SPC 10/255 SPC "0.7";
	colors[2]	  = 242/255 SPC 141/255 SPC 10/255 SPC "0.7";
	
	sizes[0]		= 0.7;
	sizes[1]		= 0.5;
	sizes[2]		= 0.1;
	
	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(mixashootTetrakaikimboFlashEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 25.0;
	velocityVariance = 1.0;
	ejectionOffset	= 0.0;
	thetaMin			= 0;
	thetaMax			= 0;
	phiReferenceVel  = 0;
	phiVariance		= 0;
	overrideAdvance = false;
	particles = "mixashootTetrakaikimboFlashParticle";
	uiName = "";
};

//////////////
/// SOUNDS ///
//////////////

datablock AudioProfile(mixashootPistolFire)
{
	filename    = "./sounds/5000.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(mixashootShotgunFire)
{
	filename    = "./sounds/50k.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(mixashootGunFire)
{
	filename    = "./sounds/5m.wav";
	description = AudioClose3d;
	preload = true;
};


//finding projectiles

function mixashootFind()
{
	if(!isObject(mixashootProjectiles)) // simsets are cool
		new SimSet(mixashootProjectiles){};
		
	mixashootprojectiles.clear();
	
	%file = new FileObject();
	%file.openForRead("Add-ons/Weapon_Mixashoot/blacklist.txt");
	
	while(!%file.isEOF())
	{
		%read = %file.readLine();
		
		if(%read $= "&&&&")
			break;
		
		%blacklist = %read;
	}
	
	%file.close();
	%file.delete();
	
	for(%i = 0; %i < DatablockGroup.getCount(); %i++)
	{
		%obj = DatablockGroup.getObject(%i);
		
		if(%obj.getClassName() $= "ProjectileData" && %obj.lifetime >= 75 && containsSubstringB(%obj.getName(), %blacklist)) //looking at lifetime to try to remove any chance of melee projectiles getting in there
			if(%obj.getName() !$= "bombProjectile" && %obj.getName() !$= "nukeProjectile")
				mixashootProjectiles.add(%obj);
	}
}

function containsSubstringB(%msg, %searchTokens) // because i was too stupid to use ! in front of containsSubstring
{
	%msg = strLwr(%msg);
	%searchTokens = strLwr(%searchTokens);
	while("" !$= %searchTokens)
	{
		%searchTokens = nextToken(%searchTokens, "stripToken", ",");
		%pos = strPos(%msg, %stripToken);
		
		if(%pos == -1)
			continue;
		
		if(getSubStr(%msg, %pos, strLen(%stripToken)) $= %stripToken)
			return 0;
	}
	return 1;
}

$MixashootStarted = 0;

deactivatePackage(mixashoot);
package mixashoot
{
	function GameConnection::onClientEnterGame(%client)
	{
		Parent::onClientEnterGame(%client);
		
		if($MixashootStarted == 0)
		{
			$MixashootStarted = 1;
			mixashootFind();
		}
	}
};
activatePackage(mixashoot);

exec("./gun.cs");
exec("./tetra.cs");
exec("./shotgun.cs");