//////////
// item //
//////////
datablock ItemData(mixashootTetraItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./shapes/5m.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Amazing Mixashoot MGL5M";
	iconName = "./5m";
	doColorShift = true;
	colorShiftColor = "1.0 1.0 1.0 1.0";
	image = mixashootTetraImage;
	canDrop = true;
	
	// BATTLE ROTATIONS STUFF
	BattleRotators = 1;
	br_Insane = 1;
	br_op = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(mixashootTetraImage)
{
	shapeFile = "./shapes/5m.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; 
	rotation = eulerToMatrix( "0 0 0" );
	
	correctMuzzleVector = true;
	
	className = "WeaponImage";
	item = BowItem;
	ammo = " ";
	projectile = GunProjectile;
	projectileType = Projectile;

	casing = GunShellDebris;
	shellExitDir		  = "1.0 -1.3 1.0";
	shellExitOffset	  = "0 0 0";
	shellExitVariance	= 15.0;	
	shellVelocity		 = 7.0;
	
	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = mixashootTetraItem.colorShiftColor;
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	
	stateName[2]                    = "Fire";
	stateScript[2]                  = "onFire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "rotate";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= mixashootTetrakaikimboFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	//stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;
	
	stateName[3] = "Smoke";
	stateEmitter[3]					= TetrakaikimboSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";
	
	stateName[4]			= "Reload";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateTransitionOnTriggerUp[4]     = "Ready";
};

function mixashootTetraImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	{
		%obj.playThread(2, plant);
		
		%ran = getRandom(1, mixashootProjectiles.getCount())-1;
		%projectile = mixashootProjectiles.getObject(%ran);
		
		serverPlay3D(mixashootGunFire, %obj.getPosition());
		
		%spread = 0.001;
		
		if(%projectile.muzzleVelocity < 100)
			%muzzleVelocity = 150;
		else
			%muzzleVelocity = %projectile.muzzleVelocity;
		
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		// for whatever fucking reason it doesn't want to fire from muzzlePoint(0)
		// so i'm going to have to do some fancy math to fix it
		%pos = vectorAdd(%obj.getMuzzlePoint(%slot), vectorScale("0 0 1", 0.35));
		%pos = vectorAdd(%pos, vectorScale(%obj.getMuzzleVector(%slot), 2.3));
		
		%p = new Projectile()
		{
			datablock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %pos;
			client = %obj.client;
			sourceObject = %obj;
			sourceSlot = %slot;
		};
		MissionCleanup.add(%p);
	}
	
	return %p;
}